/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TARMSITIOALMACENAMIENTO")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tarmsitioalmacenamiento.findAll", query = "SELECT t FROM Tarmsitioalmacenamiento t"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByCsitioalmacenamiento", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.csitioalmacenamiento = :csitioalmacenamiento"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByBodega", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.bodega = :bodega"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByDireccion", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.direccion = :direccion"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByLatitud", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.latitud = :latitud"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByLongitud", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.longitud = :longitud"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByResponsable", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.responsable = :responsable"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByTelefono", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.telefono = :telefono"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByReferencia", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.referencia = :referencia"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByIdentificacion", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.identificacion = :identificacion"),
    @NamedQuery(name = "Tarmsitioalmacenamiento.findByEstado", query = "SELECT t FROM Tarmsitioalmacenamiento t WHERE t.estado = :estado")})
public class Tarmsitioalmacenamiento implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "CSITIOALMACENAMIENTO")
    private String csitioalmacenamiento;
    @Column(name = "BODEGA")
    private String bodega;
    @Column(name = "DIRECCION")
    private String direccion;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "LATITUD")
    private BigDecimal latitud;
    @Column(name = "LONGITUD")
    private BigDecimal longitud;
    @Column(name = "RESPONSABLE")
    private String responsable;
    @Column(name = "TELEFONO")
    private String telefono;
    @Column(name = "REFERENCIA")
    private String referencia;
    @Column(name = "IDENTIFICACION")
    private String identificacion;
    @Column(name = "ESTADO")
    private String estado;
    @JoinColumn(name = "PERSONCODE", referencedColumnName = "PERSONCODE")
    @ManyToOne
    private Tcustperson personcode;
    @JoinColumns({
        @JoinColumn(name = "TIPOCOMERCIO", referencedColumnName = "CATALOG"),
        @JoinColumn(name = "TIPOCOMERCIOCODIGO", referencedColumnName = "CATALOGCODE")})
    @ManyToOne
    private Tgenecatalogdetail tgenecatalogdetail;
    @JoinColumns({
        @JoinColumn(name = "COUNTRYCODE", referencedColumnName = "COUNTRYCODE"),
        @JoinColumn(name = "PROVINCECODE", referencedColumnName = "PROVINCECODE"),
        @JoinColumn(name = "CANTONCODE", referencedColumnName = "CANTONCODE"),
        @JoinColumn(name = "CITYCODE", referencedColumnName = "CITYCODE")})
    @ManyToOne
    private Tgenecity tgenecity;
    @JoinColumns({
        @JoinColumn(name = "COUNTRYCODE", referencedColumnName = "COUNTRYCODE"),
        @JoinColumn(name = "PROVINCECODE", referencedColumnName = "PROVINCECODE"),
        @JoinColumn(name = "CANTONCODE", referencedColumnName = "CANTONCODE"),
        @JoinColumn(name = "PARROQUIACODE", referencedColumnName = "PARROQUIACODE")})
    @ManyToOne
    private Tgeneparroquia tgeneparroquia;
    @OneToMany(mappedBy = "csitioalmacenamiento")
    private Collection<Tarminspeccion> tarminspeccionCollection;

    public Tarmsitioalmacenamiento() {
    }

    public Tarmsitioalmacenamiento(String csitioalmacenamiento) {
        this.csitioalmacenamiento = csitioalmacenamiento;
    }

    public String getCsitioalmacenamiento() {
        return csitioalmacenamiento;
    }

    public void setCsitioalmacenamiento(String csitioalmacenamiento) {
        this.csitioalmacenamiento = csitioalmacenamiento;
    }

    public String getBodega() {
        return bodega;
    }

    public void setBodega(String bodega) {
        this.bodega = bodega;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public BigDecimal getLatitud() {
        return latitud;
    }

    public void setLatitud(BigDecimal latitud) {
        this.latitud = latitud;
    }

    public BigDecimal getLongitud() {
        return longitud;
    }

    public void setLongitud(BigDecimal longitud) {
        this.longitud = longitud;
    }

    public String getResponsable() {
        return responsable;
    }

    public void setResponsable(String responsable) {
        this.responsable = responsable;
    }

    public String getTelefono() {
        return telefono;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public String getReferencia() {
        return referencia;
    }

    public void setReferencia(String referencia) {
        this.referencia = referencia;
    }

    public String getIdentificacion() {
        return identificacion;
    }

    public void setIdentificacion(String identificacion) {
        this.identificacion = identificacion;
    }

    public String getEstado() {
        return estado;
    }

    public void setEstado(String estado) {
        this.estado = estado;
    }

    public Tcustperson getPersoncode() {
        return personcode;
    }

    public void setPersoncode(Tcustperson personcode) {
        this.personcode = personcode;
    }

    public Tgenecatalogdetail getTgenecatalogdetail() {
        return tgenecatalogdetail;
    }

    public void setTgenecatalogdetail(Tgenecatalogdetail tgenecatalogdetail) {
        this.tgenecatalogdetail = tgenecatalogdetail;
    }

    public Tgenecity getTgenecity() {
        return tgenecity;
    }

    public void setTgenecity(Tgenecity tgenecity) {
        this.tgenecity = tgenecity;
    }

    public Tgeneparroquia getTgeneparroquia() {
        return tgeneparroquia;
    }

    public void setTgeneparroquia(Tgeneparroquia tgeneparroquia) {
        this.tgeneparroquia = tgeneparroquia;
    }

    @XmlTransient
    public Collection<Tarminspeccion> getTarminspeccionCollection() {
        return tarminspeccionCollection;
    }

    public void setTarminspeccionCollection(Collection<Tarminspeccion> tarminspeccionCollection) {
        this.tarminspeccionCollection = tarminspeccionCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (csitioalmacenamiento != null ? csitioalmacenamiento.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarmsitioalmacenamiento)) {
            return false;
        }
        Tarmsitioalmacenamiento other = (Tarmsitioalmacenamiento) object;
        if ((this.csitioalmacenamiento == null && other.csitioalmacenamiento != null) || (this.csitioalmacenamiento != null && !this.csitioalmacenamiento.equals(other.csitioalmacenamiento))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tarmsitioalmacenamiento[ csitioalmacenamiento=" + csitioalmacenamiento + " ]";
    }
    
}
